## catch2 3.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# detect if Catch is being bundled,
# disable testsuite in that case
if(NOT DEFINED PROJECT_NAME)
  set(NOT_SUBPROJECT ON)
else()
  set(NOT_SUBPROJECT OFF)
endif()

option(CATCH_INSTALL_DOCS "Install documentation alongside library" ON)
option(CATCH_INSTALL_EXTRAS "Install extras (CMake scripts, debugger helpers) alongside library" ON)
option(CATCH_DEVELOPMENT_BUILD "Build tests, enable warnings, enable Werror, etc" OFF)
option(CATCH_ENABLE_REPRODUCIBLE_BUILD "Add compiler flags for improving build reproducibility" ON)

include(CMakeDependentOption)
cmake_dependent_option(CATCH_BUILD_TESTING "Build the SelfTest project" ON "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_BUILD_EXAMPLES "Build code examples" OFF "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_BUILD_EXTRA_TESTS "Build extra tests" OFF "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_BUILD_FUZZERS "Build fuzzers" OFF "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_ENABLE_COVERAGE "Generate coverage for codecov.io" OFF "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_ENABLE_WERROR "Enables Werror during build" ON "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_BUILD_SURROGATES "Enable generating and building surrogate TUs for the main headers" OFF "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_ENABLE_CONFIGURE_TESTS "Enable CMake configuration tests. WARNING: VERY EXPENSIVE" OFF "CATCH_DEVELOPMENT_BUILD" OFF)
cmake_dependent_option(CATCH_ENABLE_CMAKE_HELPER_TESTS "Enable CMake helper tests. WARNING: VERY EXPENSIVE" OFF "CATCH_DEVELOPMENT_BUILD" OFF)


# Catch2's build breaks if done in-tree. You probably should not build
# things in tree anyway, but we can allow projects that include Catch2
# as a subproject to build in-tree as long as it is not in our tree.
if (CMAKE_BINARY_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    message(FATAL_ERROR "Building in-source is not supported! Create a build dir and remove ${CMAKE_SOURCE_DIR}/CMakeCache.txt")
endif()

project(Catch2
  VERSION 3.7.1 # CML version placeholder, don't delete
  LANGUAGES CXX
  # HOMEPAGE_URL is not supported until CMake version 3.12, which
  # we do not target yet.
  # HOMEPAGE_URL "https://github.com/catchorg/Catch2"
  DESCRIPTION "A modern, C++-native, unit test framework."
)


# Provide path for scripts. We first add path to the scripts we don't use,
# but projects including us might, and set the path up to parent scope.
# Then we also add path that we use to configure the project, but is of
# no use to top level projects.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/extras")
if (NOT NOT_SUBPROJECT)
  set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" PARENT_SCOPE)
endif()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/CMake")

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(CatchConfigOptions)
if(CATCH_DEVELOPMENT_BUILD)
  include(CTest)
endif()

# This variable is used in some subdirectories, so we need it here, rather
# than later in the install block
set(CATCH_CMAKE_CONFIG_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/Catch2")

# We have some Windows builds that test `wmain` entry point,
# and we need this change to be present in all binaries that
# are built during these tests, so this is required here, before
# the subdirectories are added.
if(CATCH_TEST_USE_WMAIN)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ENTRY:wmainCRTStartup")
endif()


# Basic paths
set(CATCH_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SOURCES_DIR ${CATCH_DIR}/src/catch2)
set(SELF_TEST_DIR ${CATCH_DIR}/tests/SelfTest)

# We need to bring-in the variables defined there to this scope
add_subdirectory(src)

# Build tests only if requested
if (BUILD_TESTING AND CATCH_BUILD_TESTING AND NOT_SUBPROJECT)
    find_package(PythonInterp 3 REQUIRED)
    if (NOT PYTHONINTERP_FOUND)
        message(FATAL_ERROR "Python not found, but required for tests")
    endif()
    add_subdirectory(tests)
endif()

if(CATCH_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(CATCH_BUILD_EXTRA_TESTS)
    add_subdirectory(tests/ExtraTests)
endif()

if(CATCH_BUILD_FUZZERS)
    add_subdirectory(fuzzing)
endif()

if (CATCH_DEVELOPMENT_BUILD)
    add_warnings_to_targets("${CATCH_WARNING_TARGETS}")
endif()

# Only perform the installation steps when Catch is not being used as
# a subproject via `add_subdirectory`, or the destinations will break,
# see https://github.com/catchorg/Catch2/issues/1373
if (NOT_SUBPROJECT)
    configure_package_config_file(
        ${CMAKE_CURRENT_LIST_DIR}/CMake/Catch2Config.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/Catch2Config.cmake
        INSTALL_DESTINATION
          ${CATCH_CMAKE_CONFIG_DESTINATION}
    )

    write_basic_package_version_file(
      "${CMAKE_CURRENT_BINARY_DIR}/Catch2ConfigVersion.cmake"
      COMPATIBILITY
        SameMajorVersion
    )

    install(
      FILES
        "${CMAKE_CURRENT_BINARY_DIR}/Catch2Config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/Catch2ConfigVersion.cmake"
      DESTINATION
        ${CATCH_CMAKE_CONFIG_DESTINATION}
    )

    # Install documentation
    if(CATCH_INSTALL_DOCS)
      install(
        DIRECTORY
          docs/
        DESTINATION
          "${CMAKE_INSTALL_DOCDIR}"
        PATTERN "doxygen" EXCLUDE
      )
    endif()

    if(CATCH_INSTALL_EXTRAS)
        # Install CMake scripts
        install(
          FILES
            "extras/ParseAndAddCatchTests.cmake"
            "extras/Catch.cmake"
            "extras/CatchAddTests.cmake"
            "extras/CatchShardTests.cmake"
            "extras/CatchShardTestsImpl.cmake"
          DESTINATION
            ${CATCH_CMAKE_CONFIG_DESTINATION}
        )
    
        # Install debugger helpers
        install(
          FILES
            "extras/gdbinit"
            "extras/lldbinit"
          DESTINATION
            ${CMAKE_INSTALL_DATAROOTDIR}/Catch2
        )
    endif()

    ## Provide some pkg-config integration
    set(PKGCONFIG_INSTALL_DIR
        "${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig"
        CACHE PATH "Path where catch2.pc is installed"
    )
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/CMake/catch2.pc.in
      ${CMAKE_CURRENT_BINARY_DIR}/catch2.pc
      @ONLY
    )
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/CMake/catch2-with-main.pc.in
      ${CMAKE_CURRENT_BINARY_DIR}/catch2-with-main.pc
      @ONLY
    )
    install(
      FILES
        "${CMAKE_CURRENT_BINARY_DIR}/catch2.pc"
        "${CMAKE_CURRENT_BINARY_DIR}/catch2-with-main.pc"
      DESTINATION
        ${PKGCONFIG_INSTALL_DIR}
    )

    # CPack/CMake started taking the package version from project version 3.12
    # So we need to set the version manually for older CMake versions
    if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
        set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
    endif()

    set(CPACK_PACKAGE_CONTACT "https://github.com/catchorg/Catch2/")


    include( CPack )

endif()

=== debian/changelog ===
catch2 (3.7.1-0.6) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:25:56 +0200

catch2 (3.7.1-0.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Add hardening=+pie to DEB_BUILD_MAINT_OPTIONS (Closes: #1095522)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 08 Feb 2025 18:38:12 +0100

catch2 (3.7.1-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Add the "allow-stderr" restriction for the SelfTest autopkgtest: on certain
    architectures GCC emits warnings about very old GCC ABI changes.
  * Append -ffloat-store to the CXXFLAGS on any i386 architecture, not only on
    Linux.
  * Backport upstream commit a6ee7e20cd4011129816df7992c1a9db2ef4b58f to fix the
    TTY detection on on Hurd; patch
    upstream_Use-isatty-when-using-GNU-libc.patch.

 -- Pino Toscano <pino@debian.org>  Sat, 19 Oct 2024 21:33:48 +0200

catch2 (3.7.1-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Fix test failures on i386 (Closes: #1085386)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 18 Oct 2024 20:40:08 +0200

catch2 (3.7.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Increase alignment to maximum to work around build issues
    (Closes: #1084909)
  * debian/rules: Build without -Werror

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 18 Oct 2024 19:30:29 +0200

catch2 (3.7.1-0.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Mathieu Mirmont ]
  * control: remove Multi-arch: foreign (Closes: #1057948)

  [ Stephan Lachnit ]
  * New upstream version 3.7.1

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sun, 06 Oct 2024 09:33:35 +0200

catch2 (3.4.0-2) unstable; urgency=medium

  * control: rename package to allow for smoother transition (Closes: #1055237)
  * tests/SelfTest: build & run upstream test tool
  * NEWS: add a link to the v2-to-v3 migration file

 -- Mathieu Mirmont <mat@parad0x.org>  Sun, 19 Nov 2023 21:48:13 +0100

=== debian/control ===
Source: catch2
Section: devel
Priority: optional
Maintainer: Mathieu Mirmont <mat@parad0x.org>
Build-Depends: cmake, debhelper-compat (= 13), python3
Standards-Version: 4.6.2
Homepage: https://github.com/catchorg/Catch2
Vcs-Browser: https://salsa.debian.org/debian/catch2
Vcs-Git: https://salsa.debian.org/debian/catch2.git
Rules-Requires-Root: no

Package: libcatch2-dev
Architecture: any
Depends: ${misc:Depends}
Replaces: catch2 (<< 3.4.0-2~)
Breaks: catch2 (<< 3.4.0-2~)
Description: C++ Automated Test Cases in Headers
 Catch2 is mainly a unit testing framework for C++, but it also
 provides basic micro-benchmarking features, and simple BDD macros.
 .
 Catch2's main advantage is that using it is both simple and natural.
 Test names do not have to be valid identifiers, assertions look like
 normal C++ boolean expressions, and sections provide a nice and local
 way to share set-up and tear-down code in tests.
 .
 If you've been using Catch2 v2, please see the migrate-v2-to-v3.md
 file in the package documentation. v3 brings a bunch of significant
 changes, the big one being that Catch2 is no longer a single-header
 library. Catch2 now behaves as a normal library, with multiple
 headers and separately compiled implementation.

Package: catch2
Depends: libcatch2-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: C++ Automated Test Cases in Headers (transitional package)
 This is a transitional package. It can safely be removed.

=== debian/tests/control ===
Tests: SelfTest
Depends: cmake, pkgconf, make, g++, libcatch2-dev
Restrictions: allow-stderr
